import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

import '../../fast_app.dart';

/// iOS android macos window
class PhotoViewNew extends StatefulWidget {
  final List pics;
  final bool isImg;
  final int index;

  PhotoViewNew(this.pics, this.index, {this.isImg = false});

  @override
  _PhotoViewNewState createState() => _PhotoViewNewState();
}

class _PhotoViewNewState extends State<PhotoViewNew> {
  int currentIndex = 0;

  @override
  void initState() {
    super.initState();
    setState(() => currentIndex = widget.index);
  }

  @override
  void dispose() {
    super.dispose();
  }

  void preview() {
    if (currentIndex > 0) {
      setState(() {
        currentIndex--;
      });
    }
  }

  void next() {
    if (currentIndex < widget.pics.length - 1) {
      setState(() {
        currentIndex++;
      });
    }
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      backgroundColor: Colors.black,
      body: Stack(
        children: <Widget>[
          SizedBox(
            width: double.infinity,
            height: double.infinity,
            child: InteractiveViewer(
              child: CachedNetworkImage(
                imageUrl: widget.pics[currentIndex],
                fit: BoxFit.contain,
              ),
            ),
          ),
          Positioned(
            bottom: 20.0,
            left: 0,
            right: 0,
            child: Container(
              width: double.infinity,
              height: 25.0,
              alignment: Alignment.center,
              child: Text(
                '${currentIndex + 1}/${widget.pics.length}',
                style: TextStyle(color: Colors.white, fontSize: 18),
              ),
            ),
          ),
          Positioned(
            top: 0,
            left: 20.0,
            bottom: 0,
            child: Container(
              width: 80,
              alignment: Alignment.center,
              child: GestureDetector(
                child: Container(
                  child: Icon(
                    CupertinoIcons.left_chevron,
                    color: Colors.white,
                  ),
                  padding: EdgeInsets.symmetric(horizontal: 10, vertical: 10),
                  decoration: BoxDecoration(
                      borderRadius: BorderRadius.circular(30),
                      color: Colors.grey.withAlpha(50)),
                ),
                onTap: () => preview(),
              ),
            ),
          ),
          Positioned(
            top: 0,
            right: 20.0,
            bottom: 0,
            child: Container(
              width: 80,
              alignment: Alignment.center,
              child: GestureDetector(
                child: Container(
                  child: Icon(
                    CupertinoIcons.right_chevron,
                    color: Colors.white,
                  ),
                  padding: EdgeInsets.symmetric(horizontal: 10, vertical: 10),
                  decoration: BoxDecoration(
                      borderRadius: BorderRadius.circular(30),
                      color: Colors.grey.withAlpha(50)),
                ),
                onTap: () => next(),
              ),
            ),
          ),
        ],
      ),
    );
  }
}
